#ifndef _BIP_Engine_RandomScheduler_HPP_
#define _BIP_Engine_RandomScheduler_HPP_

#include "Scheduler.hpp"
#include "Compound.hpp"
#include "Engine.hpp"

class BipError;

/** \brief Compute execution sequences in which interactions
 * are chosen randomly.
 */
class RandomScheduler : public Scheduler {
 public:
  RandomScheduler(Engine &engine, bool verbose = true, bool debug = false, bool interactive = false, bool randomSeed = true, unsigned int seed = 0);
  virtual ~RandomScheduler();

  virtual void run();

  bool verbose() const { return mVerbose; }
  bool debug() const { return mDebug; }
  bool interactive() const { return mInteractive; }
  bool randomSeed() const { return mRandomSeed; }
  unsigned int seed() const { return mSeed; }


 protected:
  void handleError(BipError &error);
  void print();
  void print(const Compound &compound, string tab);

  bool mVerbose;
  bool mDebug;
  bool mInteractive;
  bool mRandomSeed;
  unsigned int mSeed;
};

#endif // _BIP_Engine_RandomScheduler_HPP_
